<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<meta http-equiv="X-UA-Compatible" content="ie=edge">
	<title>Observer Pattern</title>
	<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
	<link rel="stylesheet" href="css/style.css"/>
</head>
<body>
	<div class="container">
		<div class="row">
			<div class="col-md-4">
				<h1 class="lead">Observer Pattern</h1>
				<hr/>
				<p>
					Observer pattern is used when there is one to many relationship between objects such as if one object is modified, its dependent objects are to be notified automatically and corresponding changes are done to all dependent objects .
				</p>
				<div class="square" id="elementObserver1" onclick="model.increment()"></div>
				<hr/>
				<button class="btn btn-outline-primary" type="button" onclick="model.increment()">Increment</button>
				<button class="btn btn-outline-info" type="button" onclick="model.decrement()">Decrement</button>
				<button class="btn btn-outline-danger" type="button" onclick="model.clear()">Reset</button>
			</div>
		</div>
	</div>


	<script src="js/models/NumberModel.js"></script>
	<script src="js/observers/ElementObserver.js"></script>
	<script src="js/observers/ConsoleObserver.js"></script>
	<script src="js/observers/HistoryObserver.js"></script>
	<script src="js/app.js"></script>
</body>
</html>